/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014
 * @version 2.8.0
 *
 * Grid Export Validation Module for Yii's Gridview. Supports export of
 * grid data as CSV, HTML, or Excel.
 *
 * Author: Kartik Visweswaran
 * Copyright: 2014, Kartik Visweswaran, Krajee.com
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */!function(e){replaceAll=function(e,t,o){return e.split(t).join(o)},isEmpty=function(t,o){return null===t||void 0===t||t==[]||""===t||o&&""===e.trim(t)},popupDialog=function(e,t,o,n){var i=screen.width/2-o/2,r=60;return window.open(e,t,"toolbar=no, location=no, directories=no, status=yes, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width="+o+", height="+n+", top="+r+", left="+i)},slug=function(e){return e.toLowerCase().replace(/[^\w ]+/g,"").replace(/ +/g,"-")};var t={html:'<!DOCTYPE html><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/><meta http-equiv="X-UA-Compatible" content="IE=edge;chrome=1"/>{css}<style>.kv-wrap{padding:20px;}.kv-align-center{text-align:center;}.kv-align-left{text-align:left;}.kv-align-right{text-align:right;}.kv-align-top{vertical-align:top!important;}.kv-align-bottom{vertical-align:bottom!important;}.kv-align-middle{vertical-align:middle!important;}.kv-page-summary{border-top:4px double #ddd;font-weight: bold;}.kv-table-footer{border-top:4px double #ddd;font-weight: bold;}.kv-table-caption{font-size:1.5em;padding:8px;border:1px solid #ddd;border-bottom:none;}</style><body class="kv-wrap">{data}</body>',pdf:"{before}\n{data}\n{after}",excel:'<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel"xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/>{css}<!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body>{data}</body></html>',popup:'<html style="display:table;width:100%;height:100%;"><title>Grid Export - &copy; Krajee</title><body style="display:table-cell;font-family:Helvetica,Arial,sans-serif;color:#888;font-weight:bold;line-height:1.4em;text-align:center;vertical-align:middle;width:100%;height:100%;padding:0 10px;">{msg}</body></html>'},o=function(t,o){this.$element=e(t),this.$grid=o.grid,this.$table=this.$grid.find("table"),this.$form=this.$grid.find("form.kv-export-form"),this.encoding=this.$form.find('[name="export_encoding"]').val(),this.filename=o.filename,this.showHeader=o.showHeader,this.columns=o.showHeader?"td,th":"td",this.alertMsg=o.alertMsg,this.messages=o.messages,this.exportConversions=o.exportConversions,this.config=o.config,this.popup="",this.listen()};o.prototype={constructor:o,getArray:function(t){var o=this,n=o.clean(t),i=[],r={};return void 0!=o.config.colHeads&&o.config.colHeads.length>0?i=o.config.colHeads:n.find("thead tr th").each(function(t){var n=e(this).text(),r=slug(n);i[t]=!o.config.slugColHeads||isEmpty(r)?"col_"+t:r}),n.find('tbody tr:has("td")').each(function(t){r[t]={},e(this).children("td").each(function(o){var n=i[o];r[t][n]=e(this).text()})}),r},notify:function(e){var t=this,o=t.messages,n=isEmpty(t.alertMsg)?"":t.alertMsg,i=isEmpty(o.allowPopups)?"":o.allowPopups,r=isEmpty(o.confirmDownload)?"":o.confirmDownload,l="";return l=n.length&&i.length?n+"\n\n"+i:!n.length&&i.length?i:n.length&&!i.length?n:"",r.length&&(l=l+"\n\n"+r),out=isEmpty(l)?!1:confirm(l),out||e.preventDefault(),out},setPopupAlert:function(e){var o=this;if(void 0!=o.popup.document)if(arguments.length&&arguments[1]){var n=o.popup.document.getElementsByTagName("body");setTimeout(function(){n[0].innerHTML=e},4e3)}else{var i=t.popup.replace("{msg}",e);o.popup.document.write(i)}},listenClick:function(e){var t=this,o=arguments.length>1?arguments[1]:"";t.$element.on("click",function(n){t.notify(n)&&(isEmpty(o)?t[e]():t[e](o),n.preventDefault())})},listen:function(){var e=this;e.$form.on("submit",function(){setTimeout(function(){e.setPopupAlert(e.messages.downloadComplete,!0)},1e3)}),e.$element.hasClass("export-csv")&&e.listenClick("exportTEXT","csv"),e.$element.hasClass("export-txt")&&e.listenClick("exportTEXT","txt"),e.$element.hasClass("export-html")&&e.listenClick("exportHTML"),e.$element.hasClass("export-xls")&&e.listenClick("exportEXCEL"),e.$element.hasClass("export-json")&&e.listenClick("exportJSON"),e.$element.hasClass("export-pdf")&&e.listenClick("exportPDF")},clean:function(e){var t=this,o=t.$table.clone();o.find("tr.filters").remove(),o.find("th").removeAttr("rowspan"),t.showHeader||o.find("thead").remove(),t.showPageSummary||o.find("tfoot.kv-page-summary").remove(),t.showFooter||o.find("tfoot.kv-table-footer").remove(),t.showCaption||o.find("kv-table-caption").remove(),o.find(".skip-export").remove(),o.find(".skip-export-"+e).remove();var n=o.html();return n=t.preProcess(n),o.html(n),o},preProcess:function(e){var t=this,o=t.exportConversions,n=o.length,i=e;if(n>0)for(var r=0;n>r;r++)i=replaceAll(i,o[r].from,o[r].to);return i},download:function(e,t){var o=this,n=o.$element.data("format"),i=isEmpty(o.config)?{}:o.config;o.$form.find('[name="export_filetype"]').val(e),o.$form.find('[name="export_filename"]').val(o.filename),o.$form.find('[name="export_content"]').val(t),o.$form.find('[name="export_mime"]').val(n),o.$form.find('[name="export_config"]').val("pdf"==e?JSON.stringify(i):""),o.popup=popupDialog("","kvDownloadDialog",350,120),o.popup.focus(),o.setPopupAlert(o.messages.downloadProgress),o.$form.submit()},exportHTML:function(){var o=this,n=o.clean("html"),i=o.config,r=o.config.cssFile&&i.cssFile.length?'<link href="'+o.config.cssFile+'" rel="stylesheet">':"",l=t.html.replace("{encoding}",o.encoding).replace("{css}",r).replace("{data}",e("<div />").html(n).html());o.download("html",l)},exportPDF:function(){var o=this,n=o.clean("pdf"),i=isEmpty(o.config.contentBefore)?"":o.config.contentBefore,r=isEmpty(o.config.contentAfter)?"":o.config.contentAfter,l=o.config.css,s=t.pdf.replace("{css}",l).replace("{before}",i).replace("{after}",r).replace("{data}",e("<div />").html(n).html());o.download("pdf",s)},exportTEXT:function(t){var o=this,n=o.clean(t),i=n.find("tr:has("+o.columns+")"),r=String.fromCharCode(11),l=String.fromCharCode(0),s='"'+o.config.colDelimiter+'"',a='"'+o.config.rowDelimiter+'"',c='"'+i.map(function(t,n){var i=e(n),l=i.find(o.columns);return l.map(function(t,o){var n=e(o),i=n.text();return i.replace('"','""')}).get().join(r)}).get().join(l).split(l).join(a).split(r).join(s)+'"';o.download(t,c)},exportJSON:function(){var e=this,t=e.getArray("json"),t=JSON.stringify(t,e.config.jsonReplacer,e.config.indentSpace);e.download("json",t)},exportEXCEL:function(){var o=this,n=o.clean("xls"),i=o.config;n.find("input").remove();var r=i.cssFile&&o.config.cssFile.length?'<link href="'+o.config.cssFile+'" rel="stylesheet">':"",l=t.excel.replace("{encoding}",o.encoding).replace("{css}",r).replace("{worksheet}",o.config.worksheet).replace("{data}",e("<div />").html(n).html()).replace(/"/g,"'");o.download("xls",l)}},e.fn.gridexport=function(t){var n=Array.apply(null,arguments);return n.shift(),this.each(function(){var i=e(this),r=i.data("gridexport"),l="object"==typeof t&&t;r||i.data("gridexport",r=new o(this,e.extend({},e.fn.gridexport.defaults,l,e(this).data()))),"string"==typeof t&&r[t].apply(r,n)})},e.fn.gridexport.defaults={filename:"export",showHeader:!0,showPageSummary:!0,showFooter:!0,showCaption:!0,alertMsg:"",browserPopupsMsg:"",confirmMsg:"",messages:{allowPopups:"",confirmDownload:"",downloadProgress:"",downloadComplete:""},config:{worksheet:"",colDelimiter:",",rowDelimiter:"\r\n",cssFile:"",colHeads:[],slugColHeads:!1,jsonReplacer:null,indentSpace:4,pdfSettings:""},exportConversions:{}}}(window.jQuery);
